--
-- Specialization TracAnim
--
-- @author  	Aluha74rus
-- @version 	v1.0
-- @date  		19/02/19

TracAnim = {};
TracAnim.ModDirectory = g_currentModDirectory

function TracAnim.initSpecialization()
end

function TracAnim.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Wheels, specializations)
end;

function TracAnim.registerEventListeners(vehicleType)
	for _,n in pairs( { "onLoad", "onUpdate" } ) do
		SpecializationUtil.registerEventListener(vehicleType, n, TracAnim)
	end
end

function TracAnim:onLoad(savegame)
	
    local spec = self.spec_wheels
    ---------- Право Right ---    
    self.indexTracRight = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TracWheelsRight#index"));    
    self.charIdAnimR = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TracWheelsRight#node"));
    self.clipIndexAnimR = getXMLString(self.xmlFile, "vehicle.TracWheelsRight#animationClip");
    self.spedR = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.TracWheelsRight#sped"))
    ---------- Право Right ---    
    
    ---------- Лево Left ---    
    self.indexTracLeft = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TracWheelsLeft#index"));    
    self.charIdAnimL = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.TracWheelsLeft#node"));
    self.clipIndexAnimL = getXMLString(self.xmlFile, "vehicle.TracWheelsLeft#animationClip");
    self.spedL = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.TracWheelsLeft#sped")) 
	
end;

function TracAnim:onUpdate(dt, isActiveForInput, isSelected)
    ---------- Лево Left ---
    local newX1, newY1, newZ1 = getWorldTranslation(self.indexTracLeft);
    if self.lastTranslationL == nil then
        self.lastTranslationL = {newX1, newY1, newZ1};
    end;
    local dx1, dy1, dz1 = worldDirectionToLocal(self.indexTracLeft, newX1-self.lastTranslationL[1], newY1-self.lastTranslationL[2], newZ1-self.lastTranslationL[3]);
    local movingDirectionL = 0
    if self.lastSpeedReal > 0.0001 then    
        if dz1 < 0.0001 then
            movingDirectionL = -0.5;
        elseif dz1 > -0.0001 then
            movingDirectionL = 0.5;    
        end;
    end;    
    local lastMovedDistanceL = MathUtil.vector3Length(dx1, dy1, dz1);
    self.lastTranslationL[1] = newX1
    self.lastTranslationL[2] = newY1
    self.lastTranslationL[3] = newZ1
    
    local charIdL = getAnimCharacterSet(self.charIdAnimL);
    local clipIndexL = getAnimClipIndex(charIdL, self.clipIndexAnimL);
    
    assignAnimTrackClip(charIdL , 0, clipIndexL);
    setAnimTrackLoopState(charIdL, 0, true);
    setAnimTrackSpeedScale(charIdL, 0, self.spedL*lastMovedDistanceL*movingDirectionL);
    enableAnimTrack(charIdL, 0);
    ---------- Лево Left ---
    
    ---------- Право Right ---
    local newX2, newY2, newZ2 = getWorldTranslation(self.indexTracRight);
    if self.lastTranslationR == nil then
        self.lastTranslationR = {newX2, newY2, newZ2};
    end;
    local dx2, dy2, dz2 = worldDirectionToLocal(self.indexTracRight, newX2-self.lastTranslationR[1], newY2-self.lastTranslationR[2], newZ2-self.lastTranslationR[3]);
    local movingDirectionR = 0
    if self.lastSpeedReal > 0.0001 then    
        if dz2 < 0.0001 then
            movingDirectionR = -0.5;
        elseif dz2 > -0.0001 then
            movingDirectionR = 0.5;        
        end;
    end;    
    local lastMovedDistanceR = MathUtil.vector3Length(dx2, dy2, dz2);    
    self.lastTranslationR[1] = newX2
    self.lastTranslationR[2] = newY2
    self.lastTranslationR[3] = newZ2    
        
    local charIdR = getAnimCharacterSet(self.charIdAnimR);
    local clipIndexR = getAnimClipIndex(charIdR, self.clipIndexAnimR);        

    assignAnimTrackClip(charIdR , 0, clipIndexR);
    setAnimTrackLoopState(charIdR, 0, true);
    setAnimTrackSpeedScale(charIdR, 0, self.spedR*lastMovedDistanceR*movingDirectionR);
    enableAnimTrack(charIdR, 0);
end;